/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: StaticFrame.java 9931 2010-11-19 19:58:46Z gawrilow $
*/

package de.tuberlin.polymake.common.jreality;

import java.util.Properties;

import javax.swing.JFrame;

import de.tuberlin.polymake.common.geometry.EmbeddedGeometries;
import de.tuberlin.polymake.common.geometry.PointSet;

public class StaticFrame extends de.tuberlin.polymake.common.PolymakeFrame {
	
	private static final long serialVersionUID = -5801265579728259187L;

	public StaticFrame(EmbeddedGeometries geom, String title,
			Properties params, Properties iparams, de.tuberlin.polymake.common.PolymakeControl parent) {

		super(geom, title, params, iparams, parent);

		pViewer = new Viewer(geom);
		setupFrame();
	}

	// @Override
	public void update(PointSet ps, Properties params) {
	}
	
	/* (non-Javadoc)
	 * @see de.tuberlin.polymake.common.PolymakeFrame#createHelpFrame()
	 */
	// @Override
	public JFrame createHelpFrame() {
		return new HelpFrame();
	}
	
	public void encompass() {
		pViewer.encompass();
	}
}
