/* Copyright (c) 1997-2010
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: wrap-permlib.cc 10475 2011-12-08 12:18:52Z rehn $
*/

#include "polymake/Matrix.h"
#include "polymake/Rational.h"
#include "polymake/SparseMatrix.h"
#include "polymake/IncidenceMatrix.h"
#include "polymake/Vector.h"

namespace polymake { namespace group {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0>
   FunctionInterface4perl( cols_f1, T0 ) {
      perl::Value arg0(stack[0]);
      WrapperReturn( arg0.get<T0>().cols() );
   };

   template <typename T0>
   FunctionInterface4perl( stabilizer_of_vector_x_X, T0 ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      WrapperReturn( stabilizer_of_vector(arg0, arg1.get<T0>()) );
   };
   int stabilizer_of_vector(perl::Anything,perl::Anything);

   template <typename T0>
   FunctionInterface4perl( compute_complete_coord_act_orbit_x_X, T0 ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      WrapperReturn( compute_complete_coord_act_orbit(arg0, arg1.get<T0>()) );
   };
   int compute_complete_coord_act_orbit(perl::Anything,perl::Anything);

   template <typename T0>
   FunctionInterface4perl( compute_coord_act_orbits_x_X, T0 ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      WrapperReturn( compute_coord_act_orbits(arg0, arg1.get<T0>()) );
   };
   int compute_coord_act_orbits(perl::Anything,perl::Anything);

   FunctionWrapper4perl( pm::perl::ListReturn (pm::Array<pm::Array<int, void>, void> const&) ) {
      perl::Value arg0(stack[0]);
      IndirectWrapperReturnVoid( arg0 );
   }
   FunctionWrapperInstance4perl( pm::perl::ListReturn (pm::Array<pm::Array<int, void>, void> const&) );

   FunctionWrapper4perl( pm::Array<pm::Set<int, pm::operations::cmp>, void> (perl::Object, pm::IncidenceMatrix<pm::NonSymmetric> const&) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0, arg1.get< perl::TryCanned< const IncidenceMatrix< NonSymmetric > > >() );
   }
   FunctionWrapperInstance4perl( pm::Array<pm::Set<int, pm::operations::cmp>, void> (perl::Object, pm::IncidenceMatrix<pm::NonSymmetric> const&) );

   FunctionInstance4perl(compute_coord_act_orbits_x_X, perl::Canned< const Matrix< Rational > >);
   FunctionInstance4perl(compute_coord_act_orbits_x_X, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   FunctionInstance4perl(compute_complete_coord_act_orbit_x_X, perl::Canned< const Matrix<Rational> >);
   FunctionWrapper4perl( polymake::group::PermlibGroup (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0, arg1.get< perl::TryCanned< const Set< int > > >() );
   }
   FunctionWrapperInstance4perl( polymake::group::PermlibGroup (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) );

   FunctionWrapper4perl( polymake::group::PermlibGroupOfCone (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0, arg1.get< perl::TryCanned< const Set< int > > >() );
   }
   FunctionWrapperInstance4perl( polymake::group::PermlibGroupOfCone (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) );

   FunctionWrapper4perl( perl::Object (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0, arg1.get< perl::TryCanned< const Set< int > > >() );
   }
   FunctionWrapperInstance4perl( perl::Object (polymake::group::PermlibGroup, pm::Set<int, pm::operations::cmp> const&) );

   FunctionWrapper4perl( perl::Object (pm::Array<std::string, void> const&, int) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0.get< perl::TryCanned< const Array< std::string > > >(), arg1 );
   }
   FunctionWrapperInstance4perl( perl::Object (pm::Array<std::string, void> const&, int) );

   FunctionWrapper4perl( perl::Object (perl::Object, pm::Set<int, pm::operations::cmp> const&) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturn( arg0, arg1.get< perl::TryCanned< const Set< int > > >() );
   }
   FunctionWrapperInstance4perl( perl::Object (perl::Object, pm::Set<int, pm::operations::cmp> const&) );

   FunctionInstance4perl(stabilizer_of_vector_x_X, perl::Canned< const Vector< int > >);
   FunctionInstance4perl(stabilizer_of_vector_x_X, perl::Canned< const Vector< Rational > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::ListMatrix<pm::Vector<pm::Rational> > >);
   FunctionWrapper4perl( pm::perl::ListReturn (pm::Array<pm::Array<int, void>, void> const&, perl::Object) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturnVoid( arg0.get< perl::TryCanned< const Array< Array< int > > > >(), arg1 );
   }
   FunctionWrapperInstance4perl( pm::perl::ListReturn (pm::Array<pm::Array<int, void>, void> const&, perl::Object) );

   FunctionWrapper4perl( void (pm::Array<pm::Array<int, void>, void> const&, perl::Object) ) {
      perl::Value arg0(stack[0]), arg1(stack[1]);
      IndirectWrapperReturnVoid( arg0.get< perl::TryCanned< const Array< Array< int > > > >(), arg1 );
   }
   FunctionWrapperInstance4perl( void (pm::Array<pm::Array<int, void>, void> const&, perl::Object) );

   FunctionWrapper4perl( std::string (perl::Object) ) {
      perl::Value arg0(stack[0]);
      IndirectWrapperReturn( arg0 );
   }
   FunctionWrapperInstance4perl( std::string (perl::Object) );

///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
