use application 'polytope';
use application 'group';

my $folder = '/home/thomas/dev/polymake-svn/apps/group/testsuite';

sub saveObj {
  my ($obj, $dFolder, $suffix) = @_;
  save($obj, "$folder/$dFolder/" . $obj->name . ".$suffix");
}

my $g = new Group(GENERATORS=>[[1,2,3,0]]);
$g->name = '1';
$g->TRANSVERSALS;
saveObj($g, 'basic_properties', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,0],[0,1,3,2]]);
$g->name = '2';
$g->TRANSVERSALS;
saveObj($g, 'basic_properties', 'grp');

#------------------
# ORDER

$g = new Group(GENERATORS=>[[1,2,0]]);
$g->name = 'C3';
$g->ORDER;
saveObj($g, 'ORDER', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,4,5,0],[5,4,3,2,1,0]]);
$g->name = 'D6';
$g->ORDER;
saveObj($g, 'ORDER', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,0],[0,1,3,2]]);
$g->name = 'S4';
$g->ORDER;
saveObj($g, 'ORDER', 'grp');


#------------------
# DEGREE

$g = new Group(GENERATORS=>[[1,2,0]]);
$g->name = 'C3';
$g->DEGREE;
saveObj($g, 'DEGREE', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,4,5,0],[5,4,3,2,1,0]]);
$g->name = 'D6';
$g->DEGREE;
saveObj($g, 'DEGREE', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,0],[0,1,3,2]]);
$g->name = 'S4';
$g->DEGREE;
saveObj($g, 'DEGREE', 'grp');

#------------------
# TRANSVERSAL_SIZES

$g = new Group(GENERATORS=>[[1,2,0]]);
$g->name = 'C3';
$g->TRANSVERSAL_SIZES;
saveObj($g, 'TRANSVERSAL_SIZES', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,4,5,0],[5,4,3,2,1,0]]);
$g->name = 'D6';
$g->TRANSVERSAL_SIZES;
saveObj($g, 'TRANSVERSAL_SIZES', 'grp');

$g = new Group(GENERATORS=>[[1,2,3,0],[0,1,3,2]]);
$g->name = 'S4';
$g->TRANSVERSAL_SIZES;
saveObj($g, 'TRANSVERSAL_SIZES', 'grp');

#--------------------
# permlib_helpers

my $cyc_not1="";
my $cyc_not2="   ";
my $cyc_not3="(1,2,3)";
my $cyc_not4=new String("(1,2,3)");
my $cyc_not5=" (1 , 2,3)";
my $cyc_not6="(1,2)(3,4)";
my $cyc_not7="(1,2),(3,4)";
my $cyc_not8="(3,4)(5,6,7),(2,8,9)(10,11)(13,12)";
my $cyc_not9="(2,5),(7,1),(8)";

$g = groupFromCyclicNotation($cyc_not1);
$g->name = '1';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not2);
$g->name = '2';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not3);
$g->name = '3';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not4);
$g->name = '4';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not5);
$g->name = '5';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not6);
$g->name = '6';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not7);
$g->name = '7';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not8);
$g->name = '8';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');

$g = groupFromCyclicNotation($cyc_not9);
$g->name = '9';
$g->TRANSVERSALS;
saveObj($g, 'permlib_helpers', 'grp');


#----------------------
# stabilizers

my $g1=new Group(GENERATORS=>[[1,2,0]]);
my $s1=new Set<Int>(1);
my $s2=new Set<Int>(0,1,2);
my $g2=construct_symmetric_group(4);
my $g3=new GroupOfCone($g2,DOMAIN=>3);
my $s3=new Set<Int>(1,3);
my $vec1=new Vector<Rational>(1,1/2,1/2,3/4);
my $g4=new Group(GENERATORS=>[[1,0,2]]);
my $vec2=new Vector<Int>(1,3,3,4,4);

$g = stabilizer_of_set($g1, $s1);
$g->name = '1';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

$g = stabilizer_of_set($g1, $s2);
$g->name = '2';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

$g = stabilizer_of_set($g2, $s2);
$g->name = '3';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

$g = stabilizer_of_set($g3, $s3);
$g->name = '4';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

$g = stabilizer_of_vector($g4, $vec1);
$g->name = '5';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

$g = stabilizer_of_vector($g3, $vec2);
$g->name = '6';
$g->TRANSVERSALS;
saveObj($g, 'stabilizers', 'grp');

