/* Copyright (c) 1997-2011
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: detect_multiple.cc 10101 2011-03-30 13:58:06Z sherrmann $
*/

#include "polymake/client.h"
#include "polymake/Matrix.h"
#include "polymake/hash_set"


namespace polymake { namespace polytope {

template <typename Scalar>
bool detect_multiple(const Matrix<Scalar> &mat)
{
   hash_set<Vector<Scalar> > all;
   for (typename Entire<Rows<Matrix<Scalar> > >::const_iterator v=entire(rows(mat));!v.at_end();++v)
      if (!all.insert(*v).second) return true;
   return false;
}

FunctionTemplate4perl("detect_multiple(Matrix)");

} }

// Local Variables:
// mode:C++
// c-basic-offset:3
// indent-tabs-mode:nil
// End:
